package jex;

import java.awt.*;
import java.awt.font.*;
import java.awt.geom.*;
import java.awt.image.BufferedImage;

public class Jexawt{

	public Jexawtgraphics getGraphics(Graphics2D g){
		return new Jexawtgraphics(g);
	}

	public Jexawtfont getFont(){
		return new Jexawtfont();
	}

	class Jexawtfont extends mFont{

		public String face;
		public int style;
		public int size;

		public Font f;
		public GlyphMetrics gm;
		Rectangle2D r; 
	

		public Jexawtfont(){};

		public Jexawtfont(String face, int style, int size){
			this.face = face;
			this.style = style;
			this.size = size;
			f = new Font(face, style, size);
		}

		public mFont getFont(String face, int style, int size){
			return new Jexawtfont(face, style, size);
		}

		public mFont dup(){
			Jexawtfont jaf = new Jexawtfont(face, style, size);
			jaf.setFont(f);
			return jaf;
		}

		public void setFont(Font f){
			this.f = f;
		}

		public float getItalicAngle(){return f.getItalicAngle();}

		public double getWidth(){
			return r.getWidth();
		}

		public double getHeight(){
			return r.getHeight();
		}

		public double getY(){
			return r.getY();
		}

		public mFont deriveFont(double a, double b, double c, double d, double e, double f){
			return deriveFont(new AffineTransform(a, b, c, d, e, f));
		}

		public mFont deriveFont(float a, float b, float c, float d, float e, float f){
			return deriveFont(new AffineTransform(a, b, c, d, e, f));
		}

		public mFont deriveFont(AffineTransform a){
			Font ff = f.deriveFont(a);
			Jexawtfont jaf = (Jexawtfont) this.dup();
			jaf.setFont(ff);
			return jaf;
		}	

		public void reset(char tt[], mGraphics g){
			Jexawtgraphics ag;
			try{
				ag = (Jexawtgraphics) g;
			}
			catch(Exception e){System.err.println(e);return;}
			Graphics2D gg = ag.g;
			FontRenderContext frc = gg.getFontRenderContext();
			GlyphVector v = f.createGlyphVector(frc, tt);
			gm = v.getGlyphMetrics(0);
			r = gm.getBounds2D();
		}
	
		public float getLSB(){return gm.getLSB();}
	
	}

	public class Jexawtgraphics extends mGraphics{

		public Graphics2D g = null;

		public boolean isNull(){
			if(g == null) return true;
			return false;
		}

		public Jexawtgraphics(Graphics2D g){
			this.g = g;
		}

		public void createGraphics(){
			BufferedImage bi = new BufferedImage(1, 1, BufferedImage.TYPE_INT_BGR);
			g = bi.createGraphics();
		}
		
		public void setColor(mColor mc){
			Color c = new Color(mc.r, mc.g, mc.b);
			g.setColor(c);
		}

		public void drawLine(double a, double b, double c, double d){
			g.draw(new Line2D.Double(a, b, c, d));
		}

		public void drawRound(double a, double b, double c, double d, double e, double f){
			g.draw(new RoundRectangle2D.Double(a, b, c, d, e, f));
		}

		public int charWidth(int a){
			FontMetrics fm = g.getFontMetrics();
			return fm.charWidth(a);
		}

		public int getLeading(){
			FontMetrics fm = g.getFontMetrics();
			return fm.getLeading();
		}			

		public int getAscent(){
			FontMetrics fm = g.getFontMetrics();
			return fm.getAscent();
		}

		public int getDescent(){
			FontMetrics fm = g.getFontMetrics();
			return fm.getDescent();
		}

		public void setFont(mFont f){
			Jexawtfont jaf = (Jexawtfont) f;
			g.setFont(jaf.f);
		}

		public void drawString(String s, int x, int y){
			g.drawString(s, x, y);
		}

		public void fillRound(double a, double b, double c, double d, double e, double f){
			g.fill(new RoundRectangle2D.Double(a, b, c, d, e, f));
		}

		public void fill(double a, double b, double c, double d){
			g.fill(new Rectangle2D.Double(a, b, c, d));
		}	

		public void setPaint(mColor mc){
			Color c = new Color(mc.r, mc.g, mc.b);
			g.setPaint(c);
		}

		public FontRenderContext getFontRenderContext(){
			return g.getFontRenderContext();
		}
	}
} 
